#!/usr/bin/ruby

require 'json'
require 'socket'
require 'date'

processes = {}

$host = Socket.gethostname

$time = Time.now.to_i

$output = []

if ! File.exists?('/var/tmp/software_data_finished.json')
  exit 0
end

File.rename("/var/tmp/software_data_finished.json", "/var/tmp/software_data_finished.json.#{$time}")

jobs = JSON.parse(File.read("/var/tmp/software_data_finished.json.#{$time}"))

exit 0 if jobs['processes'] == nil

jobs['processes'].each do |k, v| 
  if v['time'].to_i > 0 and v['cputime'].to_i > 0
     if v['job'] != nil and v['job'][0] =~ /job/
        job = v['job'][0].sub(/job\[/, '').sub(/\]$/,'')
     elsif v['job'] != nil and v['job'][1] =~ /job/
        job = v['job'][1].sub(/job\[/, '').sub(/\]$/,'')
     end
     if job != nil
       if v['exe_path'] =~ /afs\/ics.muni.cz\/software/
         mod = v['exe_path'].sub(/.*afs\/ics.muni.cz\/software\//, '').sub(/\/.*/, '')
       end
       $output << { 'name' => 'jobsaccount', 'user' => v['user'], 'walltime' => v['time'], 
                    'path'=>v['exe_path'], 'cmd' => v['command'], 'bin' => v['exe_path'].sub(/.*\//, ''), 
                    'swap' => v['vm_swap_bytes'], 'mem_rss' => v['vm_rss_bytes'],
                    'cputime' => v['cputime'],
                    'host' => $host, 'time' => $time, 'wid' => nil, 'job' => job, 'module' => mod }
     end
  end
end

puts JSON.pretty_generate($output)

f = File.new("/var/tmp/jobsstats.json.new", "w", 0644)
f.write(JSON.pretty_generate($output))
f.close

File.rename("/var/tmp/jobsstats.json.new", "/var/tmp/jobsstats.json")
